require 'yaml'
require 'sprockets'
require 'pathname'
require_relative "orkester/version"
require_relative "orkester/middleware"
require_relative "orkester/cli"
require_relative "orkester/main"
require_relative "orkester/router"
require_relative "orkester/context"
require_relative "orkester/compiler"
require_relative "orkester/package_handler"

require_relative "orkester/asset_helpers" if defined?(Rails) && defined?(Rails::Railtie)
require_relative "orkester/railtie" if defined?(Rails) && defined?(Rails::Railtie)

module Orkester

  def self.app 
    app = Orkester::Middleware.new
  end

  def self.root
    if defined?(Rails) && defined?(Rails.root)
      Rails.root.join('app/packages')
    else
      root = Pathname('.').expand_path
      root.join("packages")
    end
  end
end
