module Orkester
  class Compiler

    def initialize(args)
      @context = args[:context]
      @package_defination = args[:package_defination]
      @install_location = @package_defination["location"] || @package_defination["name"]
      @assets = ::Sprockets::Environment.new @context.root.join(@install_location) 
      @assets.append_path 'javascripts'
      @assets.append_path 'stylesheets'
      @assets.append_path 'images'
    end

    def compile
      asset_paths = {
        javascripts: "main.js",
        stylesheets: "main.css"
      }
      [:javascripts, :stylesheets].each do |asset_type|
        asset = @assets.find_asset asset_paths[asset_type]
        if asset
          arr = @context.send asset_type
          arr.push asset.source
        end
      end
      @context.included_packages.push @package_defination["name"]
    end

  end
end